# Borders scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

from    com.readerware.http import HTTPConnection

from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText
from    scrapers.scrapers import convertArtist
from    jarray import zeros, array
from    java.lang import String


def extract():
    global title,artist,label,composer,date,copyDate,running,artistLF
    global value,valueDate,copies,upc,isbn,lccn,dewey,userNumber
    global format,series,sound,rating,condition,category
    global location,keywords,played,pflag,eflag,comments
    global dateEntered,dataSource,cart,ordered
    global diskCount,artistURL,conductor
    global trackTitles,trackArtists,trackWriters,trackTimes
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,salesrank,available
    global buyerwaiting,editionNumber,image,fullDateFormat,source


    # Defaults
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    sound               = "Stereo"
    format              = "CD"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    artistLF            = ""


    # Find optional fields, pricing info etc.
    marketinfo = source

    # Find List price
    i = string.find(marketinfo, ">List Price:")

    if (i != -1):
        listprice = searchForPlus(marketinfo, ">List Price:")
        i = string.find(listprice, "$")

        if i != -1:
            listprice = searchFor(listprice, "$")
            i = string.find(listprice, "<")
            listprice = stripText(listprice[0:i])
        else:
            listprice = ""


    # Main extraction
    # Main extraction
    i = string.find(source, "class=\"book_summary\"")

    if i == -1:
        return


    # Find Image
    i = string.find(source, "class=\"book_thumbnail\"")

    if i != -1:
        source = searchForPlus(source, "class=\"book_thumbnail\"")
        source = searchForPlus(source, " SRC='")
        i = string.find(source, "'")
        tempimage = stripText(source[0:i])
        i = string.find(tempimage, "placeholder")

        if (i == -1):
            image = tempimage


    # Find Title
    source = searchForPlus(source, "class=\"book_summary\"")
    source = searchForPlus(source, "<h1>")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    title = cleanupData(title)

    i = string.find(title, " [")

    if i != -1:
        title = stripText(title[0:i])


    # Find Artist
    i = string.find(source, "class=\"author_name\"")

    if i != -1:
        source = searchForPlus(source, "class=\"author_name\"")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        artist = stripText(source[0:i])

        if artist == "Compact Disc":
            artist = "Various Artists"


    # Find Format
    i = string.find(source, "class=\"pages\"")

    if i != -1:
        source = searchForPlus(source, "class=\"pages\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        format = stripText(source[0:i])

        i = string.rfind(format, ",")

        if i != -1:
            format = stripText(format[0:i])


    # Find Publisher & date
    i = string.find(source, "class=\"publisher\"")

    if i != -1:
        source = searchForPlus(source, "class=\"publisher\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "</div>")
        label = stripText(source[0:i])

        # Find Publication Date
        i = string.rfind(label, "<br>")

        if i != -1:
            date = stripText(label[i+4:])
            label = stripText(label[0:i])

            if fullDateFormat == "false":
                i = string.rfind(date, " ")

                if i != -1:
                    date = stripText(date[i+1:])


    # Find Price
    tag = "class=\"sale_price\""
    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"list_price\""
        i = string.find(source, tag)

    if i != -1:
        source = searchForPlus(source, tag)
        source = searchFor(source, "$")
        i = string.find(source, "<")
        value = stripText(source[0:i])


    # Find UPC
    i = string.find(source, ">UPC:<")

    if i != -1:
        upc = searchForPlus(source, ">UPC:<")
        upc = searchForPlus(upc, ">")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])


    # Find remaining attributes
    i = string.find(source, ">Edition:<")

    if i != -1:
        attrs = searchForPlus(source, ">Edition:<")
        i = string.find(attrs, ">/div>")
        attrs = stripText(attrs[0:i])

        i = string.find(attrs, " minutes")

        if i != -1:
            running = stripText(attrs[i-6:])
            i = string.find(running, " ")
            running = stripText(running[i:])
            i = string.find(running, " ")
            running = stripText(running[0:i]) + " Minutes"


    # Find Comments
    comments = ""
    i = string.find(source, "class=\"review_about\"")

    if i != -1:
        temp = searchForPlus(source, "class=\"review_about\"")
        temp = searchForPlus(temp, "</div>")
        i = string.find(temp, "</div>")
        temp = stripText(temp[0:i])

        while (searchFor(temp, "align=\"justify\"") != None):
            temp = searchForPlus(temp, "align=\"justify\"")
            temp = searchForPlus(temp, ">")
            i = string.find(temp, "</p>")
            tempcomments = stripText(temp[0:i])

            tempcomments = string.replace(tempcomments, "\t", " ")
            tempcomments = string.replace(tempcomments, "<p> ", "\n\n")
            tempcomments = string.replace(tempcomments, "<p>", "\n\n")
            tempcomments = string.replace(tempcomments, "<P> ", "\n\n")
            tempcomments = string.replace(tempcomments, "<P>", "\n\n")
            tempcomments = string.replace(tempcomments, "<BR>", "\n")
            tempcomments = string.replace(tempcomments, "<br/>", "\n")
            tempcomments = string.replace(tempcomments, "<i>", "")
            tempcomments = string.replace(tempcomments, "</i>", "")
            tempcomments = string.replace(tempcomments, "<I>", "")
            tempcomments = string.replace(tempcomments, "</I>", "")
            tempcomments = string.replace(tempcomments, "<B>", "")
            tempcomments = string.replace(tempcomments, "</B>", "")
            tempcomments = string.replace(tempcomments, "<b>", "")
            tempcomments = string.replace(tempcomments, "</b>", "")
            tempcomments = string.replace(tempcomments, "</a>", "")
            tempcomments = stripText(tempcomments)

            while (searchFor(tempcomments, "<a ") != None):
                i = string.find(tempcomments, "<a ")
                j = string.find(tempcomments[i:], "\">")
                tempcomments = tempcomments[0:i] + tempcomments[i+j+2:]

            if comments != "":
                comments = comments + "\n\n" + tempcomments
            else:
                comments = comments + tempcomments


    i = string.rfind(source, "class=\"review_header\"")

    if i != -1:
        temp = stripText(source[i:])
        temp = searchForPlus(temp, ">")
        temp = searchForPlus(temp, "</div>")
        i = string.find(temp, "</div>")
        tempcomments = stripText(temp[0:i])
        i = string.find(tempcomments, "<div>")

        if i != -1:
            tempcomments = stripText(tempcomments[0:i])

        tempcomments = string.replace(tempcomments, "\t", " ")
        tempcomments = string.replace(tempcomments, "<p> ", "\n\n")
        tempcomments = string.replace(tempcomments, "<p>", "\n\n")
        tempcomments = string.replace(tempcomments, "<P> ", "\n\n")
        tempcomments = string.replace(tempcomments, "<P>", "\n\n")
        tempcomments = string.replace(tempcomments, "</p>", "")
        tempcomments = string.replace(tempcomments, "<BR>", "\n")
        tempcomments = string.replace(tempcomments, "<br/>", "\n")
        tempcomments = string.replace(tempcomments, "<i>", "")
        tempcomments = string.replace(tempcomments, "</i>", "")
        tempcomments = string.replace(tempcomments, "<I>", "")
        tempcomments = string.replace(tempcomments, "</I>", "")
        tempcomments = string.replace(tempcomments, "<B>", "")
        tempcomments = string.replace(tempcomments, "</B>", "")
        tempcomments = string.replace(tempcomments, "<b>", "")
        tempcomments = string.replace(tempcomments, "</b>", "")
        tempcomments = string.replace(tempcomments, "</a>", "")
        tempcomments = stripText(tempcomments)

        while (searchFor(tempcomments, "<a ") != None):
            i = string.find(tempcomments, "<a ")
            j = string.find(tempcomments[i:], "\">")
            tempcomments = tempcomments[0:i] + tempcomments[i+j+2:]

        if comments != "":
            comments = comments + "\n\n" + tempcomments
        else:
            comments = tempcomments

    i = string.find(comments, "See All Critics' Reviews")

    if i != -1:
        comments = stripText(comments[0:i])

    while (searchFor(comments, "\n ") != None):
        comments = string.replace(comments, "\n ", "\n")


    # Find Tracks
    i = string.find(source, ">Track list<")

    if i != -1:
        i = string.find(source, ">See All Tracks")

        if i != -1:
            url = stripText(source[i-150:])
            url = searchForPlus(url, "href=\"")
            i = string.find(url, "\">")
            url = stripText(url[0:i])
            url = string.replace(url, "&amp;", "&")
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            source = http.getContents(url)
            t2 = open("trace2.html", "w")
            t2.write(source)
            t2.close()

        disks = searchForPlus(source, ">Track list<")
        i = string.find(disks, "\n</div>")
        disks = stripText(disks[0:i])

        if string.find(disks, ">Disc: ") == -1:
            disks = ">Disc: 1<" + disks

        trackList = []
        artistList = []
        diskCount = 0

        while (searchFor(disks, ">Disc: ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc: ")
            diskid = "%02d" % diskCount

            i = string.find(disks, "</table>")
            tracks = stripText(disks[0:i])
            trackIndex = 1

            while (searchFor(tracks, "<td width=\"350\">") != None):
                tracks = searchForPlus(tracks, "<td width=\"350\">")
                tracks = searchForPlus(tracks, ".")
                i = string.find(tracks, "<")
                track = stripText(tracks[0:i])

                i = string.find(track, " - ")
                trackArtist = ""

                if i != -1:
                    if track[i+3:i+4] != "(":
                        trackArtist = stripText(track[i+3:])
                        track = stripText(track[0:i])

                trackid = "%02d" % trackIndex
                trackList.append(diskid + "-" + trackid + "-" + track)
                trackIndex = trackIndex + 1

                if trackArtist != "":
                    trackArtist = convertArtist(trackArtist)
                    artistList.append(diskid + "-" + trackid + "-" + trackArtist)
                else:
                    artistList.append(diskid + "-" + trackid + "-")

            tracks = tracks[1:]

        trackList.sort()
        trackTitles = array(trackList, String)
        artistList.sort()
        trackArtists = array(artistList, String)



def cleanupData(str):
    str = string.replace(str, "\xE2\x80\x99", "'")
    str = string.replace(str, "\xC3\xA5", "\xE5")
    return str    



try:
    extract()
finally:
    if os.path.exists("scrapers/awuserexit.py"):
        execfile("scrapers/awuserexit.py") in globals()
