# Borders scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

from    scrapers.scrapers import calcISBN10CheckDigit
from    scrapers.scrapers import convertAuthor
from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText
from    scrapers.scrapers import stripNewLines


def extract():
    global title,author,isbn,publisher,format,first,signed,date,place
    global copies,rating,condition,category,read,pflag,eflag,value
    global comments,dateEntered,dataSource,cart,ordered
    global lccn,dewey,userNumber,copyDate,valueDate,location
    global series,pages,keywords,dimensions
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global author2,author3,author4,author5,author6
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,readinglevel,salesrank,available
    global buyerwaiting,editionNumber,weight,image
    global fullDateFormat,source


    # Defaults
    first               = "N"
    signed              = "N"
    read                = "N"
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    readinglevel        = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    weight              = ""

    # No place extraction default to US
    # place = "United States"


    # Find optional fields, pricing info etc.
    marketinfo = source
    i = string.find(marketinfo, ">List Price:")

    if i != -1:
        listprice = searchForPlus(marketinfo, ">List Price:")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])

        if listprice == "N/A":
            listprice = ""


    # Main extraction
    i = string.find(source, "class=\"book_summary\"")

    if i == -1:
        return


    # Find ISBN
    i = string.find(source, "name=\"sku\"")

    if i != -1:
        isbn = searchForPlus(source, "name=\"sku\"")
        isbn = searchForPlus(isbn, "value=\"")
        i = string.find(isbn, "\"")
        isbn = stripText(isbn[0:i])
        isbn = calcISBN10CheckDigit(isbn)


    # Find Image
    i = string.find(source, "class=\"book_thumbnail\"")

    if i != -1:
        source = searchForPlus(source, "class=\"book_thumbnail\"")
        source = searchForPlus(source, " SRC='")
        i = string.find(source, "'")
        tempimage = stripText(source[0:i])
        i = string.find(tempimage, "placeholder")

        if (i == -1):
            image = tempimage


    # Find Title
    source = searchForPlus(source, "class=\"book_summary\"")
    source = searchForPlus(source, "<h1>")
    i = string.find(source, "<")
    title = stripText(source[0:i])


    # Find Author
    authorList = []
    i = string.find(source, "class=\"author_name\"")

    if i != -1:
        source = searchForPlus(source, "class=\"author_name\"")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        authors = stripText(source[0:i])

        # Add a dummy / for multiple authors
        authors = " / " + stripText(authors[0:i])

        while (searchFor(authors, " / ") != None):
            authors = searchForPlus(authors, " / ")
            i = string.find(authors, " / ")

            if (i == -1):
                author = authors
            else:
                author = stripText(authors[0:i])

            author = convertAuthor(author)
            authorList.append(author)


    if len(authorList) == 0:
        author = "No Author"

    if len(authorList) > 0:
        author = authorList[0]

    if len(authorList) > 1:
        author2 = authorList[1]

    if len(authorList) > 2:
        author3 = authorList[2]

    if len(authorList) > 3:
        author4 = authorList[3]

    if len(authorList) > 4:
        author5 = authorList[4]

    if len(authorList) > 5:
        author6 = authorList[5]


    # Find Format & pages
    i = string.find(source, "class=\"pages\"")

    if i != -1:
        source = searchForPlus(source, "class=\"pages\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        format = stripText(source[0:i])

        i = string.rfind(format, ",")

        if i != -1:
            pages = stripText(format[i+1:])
            format = stripText(format[0:i])

            i = string.rfind(pages, " ")

            if i != -1:
                pages = stripText(pages[0:i])


    # Find Publisher & date
    i = string.find(source, "class=\"publisher\"")

    if i != -1:
        source = searchForPlus(source, "class=\"publisher\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "</div>")
        publisher = stripText(source[0:i])

        # Find Publication Date
        i = string.rfind(publisher, "<br>")

        if i != -1:
            date = stripText(publisher[i+4:])
            publisher = stripText(publisher[0:i])

            if fullDateFormat == "false":
                i = string.rfind(date, " ")

                if i != -1:
                    date = stripText(date[i+1:])

        # Remove extraneous crap from publisher
        i = string.find(publisher, ", Incorporated")

        if i != -1:
            publisher = stripText(publisher[0:i])

        i = string.find(publisher, ", Limited")

        if i != -1:
            publisher = stripText(publisher[0:i])

        i = string.find(publisher, ", The")
 
        if i != -1:
            publisher = stripText(publisher[0:i])


    #Find Category
    i = string.find(source, "class=\"subject\"")

    if i != -1:
        source = searchForPlus(source, "class=\"subject\"")
        source = searchForPlus(source, "</b>")
        i = string.find(source, "<")
        category = stripText(source[0:i])
        category = string.replace(category, "\t", "")
        category = string.replace(category, "\n", "")
        category = string.replace(category, "&nbsp;", " ")
        category = string.replace(category, "&gt;", ":")
        i = string.rfind(category, " - ")

        if i != -1:
            category = stripText(category[i+3:])


    # Find Price
    tag = "class=\"sale_price\""
    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"list_price\""
        i = string.find(source, tag)

    if i != -1:
        source = searchForPlus(source, tag)
        source = searchFor(source, "$")
        i = string.find(source, "<")
        value = stripText(source[0:i])


    # Find Comments
    comments = ""
    i = string.find(source, "class=\"review_about\"")

    if i != -1:
        source = searchForPlus(source, "class=\"review_about\"")
        source = searchForPlus(source, "</div>")
        i = string.find(source, "</div>")
        temp = stripText(source[0:i])

        while (searchFor(temp, "align=\"justify\"") != None):
            temp = searchForPlus(temp, "align=\"justify\"")
            temp = searchForPlus(temp, ">")
            i = string.find(temp, "</p>")
            tempcomments = stripText(temp[0:i])

            tempcomments = string.replace(tempcomments, "\t", " ")
            tempcomments = string.replace(tempcomments, "<p> ", "\n\n")
            tempcomments = string.replace(tempcomments, "<p>", "\n\n")
            tempcomments = string.replace(tempcomments, "<P> ", "\n\n")
            tempcomments = string.replace(tempcomments, "<P>", "\n\n")
            tempcomments = string.replace(tempcomments, "<BR>", "\n")
            tempcomments = string.replace(tempcomments, "<br/>", "\n")
            tempcomments = string.replace(tempcomments, "<i>", "")
            tempcomments = string.replace(tempcomments, "</i>", "")
            tempcomments = string.replace(tempcomments, "<I>", "")
            tempcomments = string.replace(tempcomments, "</I>", "")
            tempcomments = string.replace(tempcomments, "<B>", "")
            tempcomments = string.replace(tempcomments, "</B>", "")
            tempcomments = string.replace(tempcomments, "<b>", "")
            tempcomments = string.replace(tempcomments, "</b>", "")
            tempcomments = stripText(tempcomments)

            while (searchFor(tempcomments, "<a ") != None):
                i = string.find(tempcomments, "<a ")
                j = string.find(tempcomments[i:], "\">")
                tempcomments = tempcomments[0:i] + tempcomments[i+j+2:]

            if comments != "":
                comments = comments + "\n\n" + tempcomments
            else:
                comments = comments + tempcomments

    while (searchFor(comments, "\n ") != None):
        comments = string.replace(comments, "\n ", "\n")


# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*



try:
    extract()
finally:
    if os.path.exists("scrapers/userexit.py"):
        execfile("scrapers/userexit.py") in globals()
