# nolau.com scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

from    com.readerware.http import HTTPConnection

from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText


def extract():
    global title,author,isbn,publisher,format,first,signed,date,place
    global copies,rating,condition,category,read,pflag,eflag,value
    global comments,dateEntered,dataSource,cart,ordered
    global lccn,dewey,userNumber,copyDate,valueDate,location
    global series,pages,keywords,dimensions
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global author2,author3,author4,author5,author6
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,readinglevel,salesrank,available
    global buyerwaiting,editionNumber,weight,image
    global fullDateFormat,source
    global callnumber


    # Defaults
    first               = "N"
    signed              = "N"
    read                = "N"
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    readinglevel        = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    weight              = ""


    # Find optional fields, pricing info etc.
    marketinfo = source


    # Main extraction
    # No format
    format = "Hardcover"


    i = string.find(source, "<div class=\"resultitem\">")

    if i != -1:
        source = searchForPlus(source, "<div class=\"resultitem\">")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = "http://catalogue.nla.gov.au" + stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open("trace2.html", "w")
        t2.write(source)
        t2.close()


    # Find Title
    source = searchForPlus(source, "class=\"header_title\"")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    title = string.replace(title, "<STRONG>", "")
    title = string.replace(title, "</STRONG>", "")
    title = string.replace(title, "<I>", "")
    title = string.replace(title, "</I>", "")
    title = string.replace(title, "&rsquo;", "'")

    i = string.find(title, "  ")

    if i != -1:
        title = stripText(title[0:i])

    i = string.rfind(title, " / ")

    if i != -1:
        title = stripText(title[0:i])


    # Find Author
    author = ""
    i = string.find(source, "<th>Author</th>")

    if i != -1:
        source = searchForPlus(source, "<th>Author</th>")
        source = searchForPlus(source, "<td")
        source = searchForPlus(source, ">")
        source = stripText(source)
        i = string.find(source, "</td>")
        author = stripText(source[0:i])
        i = string.find(author, "<a ")

        if i != -1:
            author = searchForPlus(author, "<a ")
            author = searchForPlus(author, "\">")
            i = string.find(author, "<")
            author = stripText(author[0:i])
        
        author = string.replace(author, "</a>", "")
        author = string.replace(author, "<STRONG>", "")
        author = string.replace(author, "</STRONG>", "")
        author = string.replace(author, "<I>", "")
        author = string.replace(author, "</I>", "")

        if string.find(author, ", ") != string.rfind(author, ", "):
            i = string.rfind(author, ", ")

            if (i != -1):
                author = stripText(author[0:i])

        if author == "<br />":
            author = ""


    if author == "":
        i = string.find(source, ">Other Authors")

        if i != -1:
            tempdata = searchForPlus(source, ">Other Authors")
            tempdata = searchForPlus(tempdata, "<td")
            tempdata = searchForPlus(tempdata, ">")
            tempdata = stripText(tempdata)

            if tempdata.startswith("<a "):
                tempdata = searchForPlus(tempdata, "\">")

            i = string.find(tempdata, "<")
            author = stripText(tempdata[0:i])

            if string.find(author, ", ") != string.rfind(author, ", "):
                i = string.rfind(author, ", ")

                if (i != -1):
                    author = stripText(author[0:i])
        else:
            author = "No Author"


    # Find Publication Data
    source = searchForPlus(source, ">Description<")
    source = searchForPlus(source, "<td")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    pubdata = stripText(source[0:i])

    i = string.find(pubdata, ":")

    if (i != -1):
        place = stripText(pubdata[0:i])
        pubdata = pubdata[i+1:]

    i = string.find(pubdata, ",")

    if (i == -1):
        publisher = pubdata
    else:
        publisher = stripText(pubdata[0:i])
        date = stripText(pubdata[i+1:])

    i = string.find(place, "[")

    if (i != -1):
        place = stripText(place[i+1:])

    i = string.find(place, "]")

    if (i != -1):
        place = stripText(place[0:i])

    i = string.find(date, "[")

    if (i != -1):
        date = stripText(date[i+1:])

    i = string.find(date, "]")

    if (i != -1):
        date = stripText(date[0:i])

    i = string.find(date, ".")

    if (i != -1):
        date = stripText(date[0:i])

    i = string.find(date, ",")

    copyDate = ""

    if (i != -1):
        copyDate = stripText(date[i+1:])
        date = stripText(date[0:i])

    i = string.find(copyDate, "c")

    if (i != -1):
        copyDate = stripText(copyDate[i+1:])

    i = string.find(date, "c")

    if (i != -1):
        date = stripText(date[i+1:])


    # Find Pages/Dimensions
    source = searchForPlus(source, "<br />")
    i = string.find(source, "<")
    descdata = stripText(source[0:i])

    i = string.find(descdata, ";")

    if (i == -1):
        pages = descdata
    else:
        pages = stripText(descdata[0:i])
        dimensions = stripText(descdata[i+1:])

    i = string.find(pages, " ")

    if i != -1:
        pages = stripText(pages[0:i])

    i = string.find(pages, ",")

    if i != -1:
        pages = stripText(pages[i+1:])

    pages = string.replace(pages, "p.", "")


    # Find ISBN
    i = string.find(source, ">ISBN<")

    if i != -1:
        source = searchForPlus(source, ">ISBN<")
        source = searchForPlus(source, "<td")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        isbn = stripText(source[0:i])

        i = string.find(isbn, " ")

        if (i != -1):
            isbn = stripText(isbn[0:i])


    # Find Comments
    i = string.find(source, ">Summary<")
    comments = ""

    if i != -1:
        source = searchForPlus(source, ">Summary<")
        source = searchForPlus(source, "<td")
        source = searchForPlus(source, ">")
        i = string.find(source, "</td>")
        comments = stripText(source[0:i])


    i = string.find(source, ">Notes<")

    if (i != -1):
        source = searchForPlus(source, ">Notes<")
        source = searchForPlus(source, "<td")
        source = searchForPlus(source, ">")
        i = string.find(source, "</td>")

        if comments == "":
            comments = stripText(source[0:i])
        else:
            comments = comments + "<BR><BR>" + stripText(source[0:i])

    comments = string.replace(comments, "\n ", "")
    comments = string.replace(comments, "\n", "")
    comments = string.replace(comments, "<BR>", "\n")
    comments = string.replace(comments, "<br />", "\n")
    comments = string.replace(comments, "</p>", "\n")
    comments = string.replace(comments, "&rsquo;", "'")

    while (searchFor(comments, "\t") != None):
        comments = string.replace(comments, "\t", " ")

    while (searchFor(comments, "  ") != None):
        comments = string.replace(comments, "  ", " ")

    while (searchFor(comments, "&nbsp; ") != None):
        comments = string.replace(comments, "&nbsp; ", " ")

    while (searchFor(comments, "\n ") != None):
        comments = string.replace(comments, "\n ", "\n")

    while (searchFor(comments, "\r ") != None):
        comments = string.replace(comments, "\r ", "\r")

    while (searchFor(comments, "<p ") != None):
        i = string.find(comments, "<p ")
        j = string.find(comments[i:], ">")

        if j == -1:
            break;

        comments = comments[0:i] + comments[i+j+1:]


    # Find Category
    i = string.find(source, ">Genre<")

    if i != -1:
        source = searchForPlus(source, ">Genre<")
        source = searchForPlus(source, "<td")
        source = searchForPlus(source, ">")
        i = string.find(source, "</td>")
        category = stripText(source[0:i])

        if category.startswith("<a "):
            category = searchForPlus(category, "\">")
            i = string.find(category, "<")
            category = stripText(category[0:i])
    else:
        i = string.find(source, ">Subjects<")

        if i != -1:
            source = searchForPlus(source, ">Subjects<")
            source = searchForPlus(source, "<td")
            source = searchForPlus(source, ">")
            i = string.find(source, "</tr>")
            categories = stripText(source[0:i])

            category = ""

            while (searchFor(categories, "href=") != None):
                categories = searchForPlus(categories, "href=")
                categories = searchForPlus(categories, ">")
                i = string.find(categories, "<")

                category = category + stripText(categories[0:i])
                categories = categories[i:]



    # Find call number
    i = string.find(source, ">Call Number:<")

    if i != -1:
        source = searchForPlus(source, ">Call Number:<")
        source = searchForPlus(source, "<TD")
        source = searchForPlus(source, ">")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        callnumber = stripText(source[0:i])





try:
    extract()
finally:
    if os.path.exists("scrapers/userexit.py"):
        execfile("scrapers/userexit.py") in globals()
