# bol.nl.com scraper
#
# copied from various sources
#

import  os
import  string

from    com.readerware.http import HTTPConnection

from    scrapers.scrapers import convertAuthor
from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText
from    scrapers.scrapers import stripHTML
from    scrapers.scrapers import stripNewLines
from    scrapers.scrapers import calcISBN10CheckDigit
from    scrapers.scrapers import calcISBN13CheckDigit



def translate_text(str):
    str = string.replace(str, "\xC2\xAE", "")
    str = string.replace(str, "\xC3\xA8", "")
    str = string.replace(str, "\xC3\xA9", "")
    str = string.replace(str, "\xC3\xAB", "")
    str = string.replace(str, "\xC3\xAD", "")
    str = string.replace(str, "\xC3\xAF", "")
    str = string.replace(str, "\xC5\xBD", "")
    str = string.replace(str, "\xE2\x80\x93", "-")
    str = string.replace(str, "\xE2\x80\x98", "'")
    str = string.replace(str, "\xE2\x80\x99", "'")
    return string.strip(str);

def extract():
    global title,author,isbn,publisher,format,first,signed,date,place
    global copies,rating,condition,category,read,pflag,eflag,value
    global comments,dateEntered,dataSource,cart,ordered
    global lccn,dewey,userNumber,copyDate,valueDate,location
    global series,pages,keywords,dimensions
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global author2,author3,author4,author5,author6
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,readinglevel,salesrank,available
    global buyerwaiting,editionNumber,weight,image
    global fullDateFormat,source


    # Defaults
    first               = "N"
    signed              = "N"
    read                = "N"
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    readinglevel        = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    weight              = ""


    # No place extraction default to US
    # place = "Netherlands"


    # is this the search page or the detail page?
    i = string.find (source, "gevonden voor \"")

    if i != -1: 
        source = searchForPlus(source, "class=\"imgwrap_thumb\"")
        source = searchForPlus(source, " href=\"")
        i = string.find(source, "\"")
        url = "http://www.bol.com" + stripText(source[0:i]);

        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open("trace2.html", "w")
        t2.write(source)
        t2.close()

    #
    # this should be the product page


   
    # Find optional fields, pricing info etc.
    marketinfo = source


    # Find List price
    i = string.find(marketinfo, "Adviesprijs:")

    if (i != -1):
        listprice = searchForPlus(marketinfo, "bol.com prijs:")
        # now the euro symbol - stored as #8364;&nbsp;PRICE
        listprice = searchForPlus (listprice, "8364; ")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])


    # Check for availability
    i = string.find(source, "Deze titel is momenteel niet leverbaar")

    if i != -1:
       available = "N";
 

    # Find Title
    tag = "class=\"main_header\""
    source = searchForPlus(source, tag)

    if source == None:
        print "can't find title"
        return

    source = searchForPlus(source, ">")
    i = string.find(source, "<");
    title = stripText(source[0:i])

    if title == "Geen zoekresultaat":
        title = ""
        print "can't find title"
        return

    title = translate_text(title)


    # Find Cover Image
    tag = "class=\"product_image_regular\""
    i = string.find(source, tag)

    if i != -1:
        source = searchForPlus(source, tag)
        source = searchForPlus(source, " src=\"")
        i = string.find(source, "\"")
        image = stripText(source[0:i])


    # Find Author
    author = ""
    authorList = []

    i = string.find(source, "Auteur:")

    if i != -1:
        source = searchForPlus(source, "Auteur:")
        i = string.find(source, "</p>")
        authors = stripText(source[0:i])

        while (searchFor(authors, "<a href") != None):
            authors = searchForPlus(authors, "<a href")
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<");
            author = stripText(authors[0:i])
            author = stripHTML(author)
            author = translate_text(author)
            author = convertAuthor(author)
            authorList.append(author)

        if len(authorList) > 0:
            author = authorList[0]

        if len(authorList) > 1:
            author2 = authorList[1]

        if len(authorList) > 2:
            author3 = authorList[2]

        if len(authorList) > 3:
            author4 = authorList[3]

        if len(authorList) > 4:
            author5 = authorList[4]

        if len(authorList) > 5:
            author6 = authorList[5]


    if title != "" and author == "":
        author = "No Author"


    # Find Format
    tag= "<strong>"
    i = string.find(source, tag)

    if i != -1 and i < 500:
        format = searchForPlus(source, tag)
        i = string.find(format, "<")
        format = stripText(format[0:i])

    # Find attributes
    i = string.find(source, "class=\"small_details\"")

    if i != -1:
        attrs = searchFor(source, "class=\"small_details\"")
        i = string.find(attrs, "</p>")
        attrs = stripText(attrs[0:i+1])


        # Find Pages - note sometimes absent
        i = string.find(attrs, "pagina's")

        if i != -1:
            pages = stripText(attrs[i-20:])
            pages = searchForPlus(pages, ">")
            i = string.find(pages, "pagina's")
            pages = stripText(pages[0:i])


        # Find Publisher
        i = string.find(attrs, "|")

        if i != -1:
            publisher = searchForPlus(attrs, "|")
            attrs = searchForPlus(attrs, "|")
            i = string.find(publisher, "|")

            if i != -1:
                publisher = stripText(publisher[0:i])

            i = string.find(publisher, "<")

            if i != -1:
                publisher = stripText(publisher[0:i])

            publisher = translate_text(publisher)


        # Find Published Date
        i = string.find(attrs, "|")

        if i != -1:
            date = searchForPlus(attrs, "|")
            i = string.find(date, "<")
            date = stripText(date[0:i])

            if fullDateFormat == "false":
                i = string.rfind(date, " ")

                if i != -1:
                    date = stripText(date[i:])


    # Find Price
    i = string.find(source, "class=\"price_tag price_tag_bol\"")

    if i != -1:
        value = searchForPlus(source, "class=\"price_tag price_tag_bol\"")
        value = searchForPlus(value, ">")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        value = stripHTML(value)
        value = string.replace(value, "&euro;", "")
        value = string.replace(value, "\xE2\x82\xAC", "")

    # Find Comments 
    i = string.find(source, "class=\"product_description\"")

    if i != -1:
        comments = searchForPlus(source, "class=\"product_description\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div>")
        comments = stripText(comments[0:i])
        comments = translate_text(comments)

        i = string.find(comments, "<div ")

        if i != -1:
            comments = stripText(comments[0:i])

        comments = string.replace(comments, "<br />", "\n")
        comments = string.replace(comments, "<br/ >", "\n")
        comments = string.replace(comments, "</a>", "")

        while (searchFor(comments, "\n ") != None):
            i = string.find(comments, "\n ")
            comments = comments[0:i+1] + comments[i+2:]

        while (searchFor(comments, "\n\n\n") != None):
            i = string.find(comments, "\n\n\n")
            comments = comments[0:i] + comments[i+1:]

        while (searchFor(comments, "<a ") != None):
                i = string.find(comments, "<a ")
                j = string.find(comments[i:], ">")
                comments = comments[0:i] + comments[i+j+1:]


    # Find Dimensions
    i = string.find(source, ">Afmetingen<")

    if i != -1:
        dimensions = searchForPlus(source, ">Afmetingen<")
        dimensions = searchForPlus(dimensions, "\">")
        i = string.find(dimensions, "<")
        dimensions = stripText(dimensions[0:i])


    # Find ISBN
    i = string.find(source, ">ISBN")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN")
        isbn = searchForPlus(isbn, "dd>")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])

        if isbn.startswith("978") == 1:
            isbn = isbn[3:]
            isbn = stripText(isbn[0:len(isbn)-1])
            isbn = calcISBN10CheckDigit(isbn)


    # Find Category
    i = string.find(source, ">Categorie")

    if i != -1:
        category = ""
        categories = searchForPlus(source, ">Categorie")
        i = string.find(categories, "<br />")
        categories = stripText(categories[0:i])
        categories = translate_text(categories)

        while (searchFor(categories, "<a href") != None):
            categories = searchForPlus(categories, "<a href")
            categories = searchForPlus(categories, "\">")
            i = string.find(categories, "<");

            if category == "":
                category = stripText(categories[0:i])
            else:
                category = category + " > " + stripText(categories[0:i])







try:
    extract()
finally:
    if os.path.exists("scrapers/userexit.py"):
        execfile("scrapers/userexit.py") in globals()
