# amazon.com scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

from    com.readerware.http import HTTPConnection

from    scrapers.scrapers import convertAuthor
from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText
from    scrapers.scrapers import stripHTML
from    scrapers.scrapers import stripNewLines


def extract():
    global title,author,isbn,publisher,format,first,signed,date,place
    global copies,rating,condition,category,read,pflag,eflag,value
    global comments,dateEntered,dataSource,cart,ordered
    global lccn,dewey,userNumber,copyDate,valueDate,location
    global series,pages,keywords,dimensions
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global author2,author3,author4,author5,author6
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,readinglevel,salesrank,available
    global buyerwaiting,editionNumber,weight,image
    global fullDateFormat,source


    # Defaults
    publisher           = "The Folio Society"
    format              = "Hardcover"
    first               = "N"
    signed              = "N"
    read                = "N"
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    readinglevel        = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    weight              = ""


    # No place extraction default to US
    # place = "United States"



    # Find optional fields, pricing info etc.
    marketinfo = source


    # Main extraction


    # Find category
    i = string.find(source, "/category/")

    if i != -1:
        source = searchForPlus(source, "/category/")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        category = stripText(source[0:i])


    # Find Title
    source = searchForPlus(source, "class=\"viewBook\"")
    source = searchForPlus(source, "<h3>")
    i = string.find(source, "<")
    title = stripText(source[0:i])


    # Find Author
    i = string.find(source, "class=\"author\"")

    if i != -1:
        source = searchForPlus(source, "class=\"author\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        author = stripText(source[0:i])

        i = string.rfind(author, " ")

        if (i != -1):
            author = stripText(author[i:]) + ", " + stripText(author[0:i])
    else:
        author = "No Author"


    # Find Image
    i = string.find(source, "class=\"largeImage\"")

    if i != -1:
        image = searchForPlus(source, "class=\"largeImage\"")
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "no-image")

        if i != -1:
            image = ""


    # Find Price
    i = string.find(source, ">Your price")

    if i != -1:
        source = source[i+1:]
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        value = stripText(source[0:i])


    # Find Attributes
    attr = ""
    i = string.find(source, "class=\"summary\"")

    if i != -1:
        attr = searchForPlus(source, "class=\"summary\"")
        attr = searchForPlus(attr, ">")
        i = string.find(attr, "</div>")
        attr = stripText(attr[0:i])

        # Find pages
        i = string.rfind(attr, " pages")

        if i != -1:
            pages = stripText(attr[i-8:])
            i = string.find(pages, " pages")
            pages = stripText(pages[0:i])
            i = string.find(pages, ",") 

            if i != -1:
                pages = searchForPlus(pages, ",")

            i = string.find(pages, ".") 

            if i != -1:
                pages = searchForPlus(pages, ".")

        # Find dimensions
        i = string.find(attr, "Size:")

        if i != -1:
            dimensions = stripText(attr[i+5:])
            i = string.find(dimensions, ",") 

            if i != -1:
                dimensions = stripText(dimensions[0:i])

            i = string.find(dimensions, ".") 

            if i != -1:
                dimensions = stripText(dimensions[0:i])

        # Find publication date
        i = string.find(attr, "Publication date:")

        if i != -1:
            date = searchForPlus(attr, "Publication date:")
            i = string.find(date, ",") 

            if i != -1:
                date = stripText(date[0:i])

            i = string.find(date, ".") 

            if i != -1:
                date = stripText(date[0:i])

            i = string.find(date, "<") 

            if i != -1:
                date = stripText(date[0:i])

            if fullDateFormat == "false":
                i = string.rfind(date, " ")

                if i != -1:
                    date = stripText(date[i+1:])


    # Find Comments
    i = string.find(source, ">About this book<")

    if i != -1:
        comments = searchForPlus(source, ">About this book<")
        comments = searchForPlus(comments, "id=\"tab0\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div>")
        comments = comments[0:i]

        if attr != "":
            comments = comments + "</p>" + attr

        comments = string.replace(comments, "\n", "")
        comments = string.replace(comments, "<p>", "")
        comments = string.replace(comments, "</p>", "\n\n")
        comments = string.replace(comments, "<br/>", "\n")
        comments = string.replace(comments, "<br />", "\n")
        comments = string.replace(comments, "<i>", "")
        comments = string.replace(comments, "</i>", "")
        comments = string.replace(comments, "&rsquo;", "'")
        comments = string.replace(comments, "&lsquo;", "'")
        comments = string.replace(comments, "&ndash;", "-")
        comments = string.replace(comments, "<small>", "")
        comments = string.replace(comments, "</small>", "")
        comments = string.replace(comments, "<em>", "")
        comments = string.replace(comments, "</em>", "")
        comments = string.replace(comments, "<strong>", "")
        comments = string.replace(comments, "</strong>", "")

        while (searchFor(comments, "<p ") != None):
            i = string.find(comments, "<p ")
            j = string.find(comments[i:], ">")
            comments = comments[0:i] + comments[i+j+1:]

        while (searchFor(comments, "  ") != None):
            i = string.find(comments, "  ")
            comments = comments[0:i+1] + comments[i+2:]

        while (searchFor(comments, "\n ") != None):
            i = string.find(comments, "\n ")
            comments = comments[0:i+1] + comments[i+2:]

        while (searchFor(comments, "\r ") != None):
            i = string.find(comments, "\r ")
            comments = comments[0:i+1] + comments[i+2:]




try:
    extract()
finally:
    if os.path.exists("scrapers/userexit.py"):
        execfile("scrapers/userexit.py") in globals()
