# Borders scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

from    scrapers.scrapers import convertAuthor
from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText


def extract():
    global title,actor1,actor2,actor3,actor4,actor5,actor6
    global actor7,actor8,actor9,actor10,director,writer
    global screenwriter,photographer,composer,editor,series
    global upc,isbn,lccn,dewey,userNumber,format,studio,place
    global date,copyDate,mpaa,wide,closedCap,sound,copies
    global rating,condition,category,viewed,pflag,eflag,value
    global valueDate,comments,dateEntered,dataSource,cart,ordered
    global copies,location,keywords,book,author,running,color
    global track1,track2,track3,track4,track5
    global track6,track7,track8,track9,track10
    global track11,track12,track13,track14,track15
    global track16,track17,track18,track19,track20
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,salesrank,available
    global buyerwaiting,editionNumber,image,fullDateFormat,source

    # No place extraction default to US
    # place = "United States"


    # Defaults
    pflag               = "Y"
    eflag               = "Y"
    color               = "Color"
    sound               = "Mono"
    wide                = "N"
    closedCap           = "N"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"


    # Find optional fields, pricing info etc.
    marketinfo = source

    # Find List price
    i = string.find(marketinfo, ">List Price:")

    if (i != -1):
        listprice = searchForPlus(marketinfo, ">List Price:")
        i = string.find(listprice, "$")

        if i != -1 and i < 50:
            listprice = searchFor(listprice, "$")
            i = string.find(listprice, "<")
            listprice = stripText(listprice[0:i])
        else:
            listprice = ""




    # Main extraction
    i = string.find(source, "class=\"book_summary\"")

    if i == -1:
        return


    # Find Image
    i = string.find(source, "class=\"book_thumbnail\"")

    if i != -1:
        source = searchForPlus(source, "class=\"book_thumbnail\"")
        source = searchForPlus(source, " SRC='")
        i = string.find(source, "'")
        tempimage = stripText(source[0:i])
        i = string.find(tempimage, "placeholder")

        if (i == -1):
            image = tempimage


    # Find Title
    source = searchForPlus(source, "class=\"book_summary\"")
    source = searchForPlus(source, "<h1>")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    title = cleanupData(title)

    i = string.find(title, " [")

    if i != -1:
        title = stripText(title[0:i])


    # Find Format
    i = string.find(source, "class=\"pages\"")

    if i != -1:
        source = searchForPlus(source, "class=\"pages\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        format = stripText(source[0:i])

        i = string.rfind(format, ",")

        if i != -1:
            format = stripText(format[0:i])


    # Find Publisher & date
    i = string.find(source, "class=\"publisher\"")

    if i != -1:
        source = searchForPlus(source, "class=\"publisher\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "</div>")
        studio = stripText(source[0:i])

        # Find Publication Date
        i = string.rfind(studio, "<br>")

        if i != -1:
            date = stripText(studio[i+4:])
            studio = stripText(studio[0:i])

            if fullDateFormat == "false":
                i = string.rfind(date, " ")

                if i != -1:
                    date = stripText(date[i+1:])


    # Find Price
    tag = "class=\"sale_price\""
    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"list_price\""
        i = string.find(source, tag)

    if i != -1:
        source = searchForPlus(source, tag)
        source = searchFor(source, "$")
        i = string.find(source, "<")
        value = stripText(source[0:i])


    # Find UPC
    i = string.find(source, ">UPC:<")

    if i != -1:
        upc = searchForPlus(source, ">UPC:<")
        upc = searchForPlus(upc, ">")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])


    # Find remaining attributes
    i = string.find(source, ">Format:<")

    if i != -1:
        attrs = searchForPlus(source, ">Format:<")

        i = string.find(attrs, "Rated ")

        if i != -1:
            mpaa = searchForPlus(attrs, "Rated ")
            i = string.find(mpaa, " ")
            mpaa = stripText(mpaa[0:i])
            i = string.find(mpaa, ",")

            if i != -1:
                mpaa = stripText(mpaa[0:i])

        i = string.find(attrs, " minutes")

        if i != -1:
            running = stripText(attrs[i-6:])
            i = string.find(running, " ")
            running = stripText(running[i:])
            i = string.find(running, " ")
            running = stripText(running[0:i]) + " Minutes"

        i = string.find(attrs, "Dolby")

        if i != -1:
            sound = searchFor(attrs, "Dolby")
            i = string.find(sound, ",")

            if i != -1:
                sound = stripText(sound[0:i])

            i = string.find(sound, "<")

            if i != -1:
                sound = stripText(sound[0:i])

        i = string.find(attrs, " WS")

        if i != -1:
            wide = "Y"
        else:
            wide = "N"


    # Find Comments
    comments = ""
    i = string.find(source, "class=\"review_about\"")

    if i != -1:
        source = searchForPlus(source, "class=\"review_about\"")
        source = searchForPlus(source, "</div>")
        i = string.find(source, "</div>")
        temp = stripText(source[0:i])

        while (searchFor(temp, "align=\"justify\"") != None):
            temp = searchForPlus(temp, "align=\"justify\"")
            temp = searchForPlus(temp, ">")
            i = string.find(temp, "</p>")
            tempcomments = stripText(temp[0:i])

            tempcomments = string.replace(tempcomments, "\t", " ")
            tempcomments = string.replace(tempcomments, "<p> ", "\n\n")
            tempcomments = string.replace(tempcomments, "<p>", "\n\n")
            tempcomments = string.replace(tempcomments, "<P> ", "\n\n")
            tempcomments = string.replace(tempcomments, "<P>", "\n\n")
            tempcomments = string.replace(tempcomments, "<BR>", "\n")
            tempcomments = string.replace(tempcomments, "<br/>", "\n")
            tempcomments = string.replace(tempcomments, "<i>", "")
            tempcomments = string.replace(tempcomments, "</i>", "")
            tempcomments = string.replace(tempcomments, "<I>", "")
            tempcomments = string.replace(tempcomments, "</I>", "")
            tempcomments = string.replace(tempcomments, "<B>", "")
            tempcomments = string.replace(tempcomments, "</B>", "")
            tempcomments = string.replace(tempcomments, "<b>", "")
            tempcomments = string.replace(tempcomments, "</b>", "")
            tempcomments = stripText(tempcomments)

            while (searchFor(tempcomments, "<a ") != None):
                i = string.find(tempcomments, "<a ")
                j = string.find(tempcomments[i:], "\">")
                tempcomments = tempcomments[0:i] + tempcomments[i+j+2:]

            if comments != "":
                comments = comments + "\n\n" + tempcomments
            else:
                comments = comments + tempcomments

    while (searchFor(comments, "\n ") != None):
        comments = string.replace(comments, "\n ", "\n")


    # Find Director
    i = string.find(source, ">Director:")

    if i != -1:
        source = searchForPlus(source, ">Director:")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        director = convertAuthor(stripText(source[0:i]))


    # Find Actors
    actorTag = ">Actors:"
    i = string.find(source, actorTag)

    if i == -1:
        actorTag = ">Featured:"
        i = string.find(source, actorTag)

    if i == -1:
        actorTag = ">Voice:"
        i = string.find(source, actorTag)

    if i == -1:
        actorTag = ">Actor:"
        i = string.find(source, actorTag)

    if i != -1:
        source = searchForPlus(source, actorTag)
        i = string.find(source, "<br/>")
        actors = " / "  + stripText(source[0:i])
        actorList = []

        while (searchFor(actors, "href=\"") != None):
            actors = searchForPlus(actors, "href=\"")
            actors = searchForPlus(actors, "\">")
            i = string.find(actors, "<")
            actor = convertAuthor(actors[0:i])
            actor = cleanupData(actor)

            actorList.append(actor)

        if len(actorList) > 0:
            actor1 = actorList[0]

        if len(actorList) > 1:
            actor2 = actorList[1]

        if len(actorList) > 2:
            actor3 = actorList[2]

        if len(actorList) > 3:
            actor4 = actorList[3]

        if len(actorList) > 4:
            actor5 = actorList[4]

        if len(actorList) > 5:
            actor6 = actorList[5]

        if len(actorList) > 6:
            actor7 = actorList[6]

        if len(actorList) > 7:
            actor8 = actorList[7]

        if len(actorList) > 8:
            actor9 = actorList[8]

        if len(actorList) > 9:
            actor10 = actorList[9]

    # Find Writer
    i = string.find(source, ">Story:")

    if i != -1:
        source2 = searchForPlus(source, ">Story:")
        source2 = searchForPlus(source2, "</b>")
        i = string.find(source2, "<")
        writer = convertAuthor(stripText(source2[0:i]))


    # Find Screenplay, will overwrite with screenwriter
    i = string.find(source, ">Screenplay:")

    if i != -1:
        source2 = searchForPlus(source, ">Screenplay:")
        source2 = searchForPlus(source2, "</b>")
        i = string.find(source2, "<")
        screenwriter = convertAuthor(stripText(source2[0:i]))


    # Find Screenwriter
    i = string.find(source, ">Screen Writer:")

    if i != -1:
        source2 = searchForPlus(source, ">Screen Writer:")
        source2 = searchForPlus(source2, "</b>")
        i = string.find(source2, "<")
        screenwriter = convertAuthor(stripText(source2[0:i]))
    else:
        i = string.find(source, ">Screenwriter:")

        if i != -1:
            source2 = searchForPlus(source, ">Screenwriter:")
            source2 = searchForPlus(source2, "</b>")
            i = string.find(source2, "<")
            screenwriter = convertAuthor(stripText(source2[0:i]))


    # Find Author
    i = string.find(source, ">Book Author:")

    if i != -1:
        source2 = searchForPlus(source, "Book Author:")
        source2 = searchForPlus(source2, "</b>")
        i = string.find(source2, "<")
        author = convertAuthor(stripText(source2[0:i]))


    # Find Director of photography
    i = string.find(source, ">Director of Photography:")

    if i != -1:
        source2 = searchForPlus(source, ">Director of Photography:")
        source2 = searchForPlus(source2, "</b>")
        i = string.find(source2, "<")
        photographer = convertAuthor(stripText(source2[0:i]))


    # Find Composer
    i = string.find(source, ">Music Contributor(s):")

    if i != -1:
        source2 = searchForPlus(source, ">Music Contributor(s):")
        source2 = searchForPlus(source2, "</b>")
        i = string.find(source2, "<")
        composer = convertAuthor(stripText(source2[0:i]))


    # Find Composer
    i = string.find(source, ">Music Score Composer")

    if i != -1:
        source2 = searchForPlus(source, ">Music Score Composer")
        source2 = searchForPlus(source2, "\">")
        i = string.find(source2, "<")
        composer = convertAuthor(stripText(source2[0:i]))


    # Find Editor
    i = string.find(source, ">Editor:")

    if i != -1:
        source2 = searchForPlus(source, ">Editor:")
        source2 = searchForPlus(source2, "</b>")
        i = string.find(source2, "<")
        editor = convertAuthor(stripText(source2[0:i]))


    # Find Price
    i = string.find(source, " Price:<")

    if i != -1:
        source = searchForPlus(source, " Price:<")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        value = stripText(source[0:i])


    # Find UPC
    source = searchForPlus(source, ">UPC:</B>")
    i = string.find(source, "<")
    upc = stripText(source[0:i])


    #Find Category
    i = string.find(source, ">Shelf Location:<")

    if i != -1:
        source = searchForPlus(source, ">Shelf Location:<")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        category = stripText(source[0:i])

        i = string.find(category, ", ")

        if i != -1:
            category = stripText(category[0:i])

        category = string.replace(category, "\t", "")
        category = string.replace(category, "\n", "")


    #Find Category
    i = string.find(source, ">Subject:<")

    if i != -1:
        source = searchForPlus(source, ">Subject:<")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        category = stripText(source[0:i])

        while (searchFor(category, ",") != None):
            i = string.find(category, ",")
            category = stripText(category[0:i]) + " : " + stripText(category[i+1:])


    #Find Tracks
    i = string.find(source, ">Table of Contents<")

    if i != -1:
        source = searchForPlus(source, ">Table of Contents<")
        i = string.find(source, "</ol>")
        tracks = stripText(source[0:i])
        trackList = []

        while (searchFor(tracks, "<li>") != None):
            tracks = searchForPlus(tracks, "<li>")
            i = string.find(tracks, "</li>")

            if (i == -1):
                track = tracks
            else:
                track = stripText(tracks[0:i])

            i = string.find(track, "<br>")

            if (i != -1):
                track = stripText(track[0:i])


            trackList.append(track)

        if len(trackList) > 0:
            track1 = trackList[0]

        if len(trackList) > 1:
            track2 = trackList[1]

        if len(trackList) > 2:
            track3 = trackList[2]

        if len(trackList) > 3:
            track4 = trackList[3]

        if len(trackList) > 4:
            track5 = trackList[4]

        if len(trackList) > 5:
            track6 = trackList[5]

        if len(trackList) > 6:
            track7 = trackList[6]

        if len(trackList) > 7:
            track8 = trackList[7]

        if len(trackList) > 8:
            track9 = trackList[8]

        if len(trackList) > 9:
            track10 = trackList[9]

        if len(trackList) > 10:
            track11 = trackList[10]

        if len(trackList) > 11:
            track12 = trackList[11]

        if len(trackList) > 12:
            track13 = trackList[12]

        if len(trackList) > 13:
            track14 = trackList[13]

        if len(trackList) > 14:
            track15 = trackList[14]

        if len(trackList) > 15:
            track16 = trackList[15]

        if len(trackList) > 16:
            track17 = trackList[16]

        if len(trackList) > 17:
            track18 = trackList[17]

        if len(trackList) > 18:
            track19 = trackList[18]

        if len(trackList) > 19:
            track20 = trackList[19]



def cleanupData(str):
    str = string.replace(str, "\xE2\x80\x99", "'")
    str = string.replace(str, "\xC3\xA5", "\xE5")
    return str    



# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*


try:
    extract()
finally:
    if os.path.exists("scrapers/vwuserexit.py"):
        execfile("scrapers/vwuserexit.py") in globals()
