# LaserDisc Database video scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

from    com.readerware.http import HTTPConnection

from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText
from    scrapers.scrapers import stripHTML


def extract():
    global title,actor1,actor2,actor3,actor4,actor5,actor6
    global actor7,actor8,actor9,actor10,director,writer
    global screenwriter,photographer,composer,editor,series
    global upc,isbn,lccn,dewey,userNumber,format,studio,place
    global date,copyDate,mpaa,wide,closedCap,sound,copies
    global rating,condition,category,viewed,pflag,eflag,value
    global valueDate,comments,dateEntered,dataSource,cart,ordered
    global copies,location,keywords,book,author,running,color
    global track1,track2,track3,track4,track5
    global track6,track7,track8,track9,track10
    global track11,track12,track13,track14,track15
    global track16,track17,track18,track19,track20
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,salesrank,available
    global buyerwaiting,editionNumber,image,imageref,fullDateFormat,source

    # No place extraction default to US
    # place = "United States"


    # Defaults
    pflag               = "Y"
    eflag               = "Y"
    color               = "Color"
    sound               = "Stereo"
    wide                = "N"
    closedCap           = "N"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    category            = ""
    format              = "LaserDisc"


    # Check for LDDB search results page and get first detail listing
    i = string.find(source, "<title>LaserDisc Database - Search")

    if i != -1:
        source = searchForPlus(source, "<title>LaserDisc Database - Search")
        source = searchFor(source, "http://www.lddb.com/laserdisc/")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)


    # Check for IMDb link and extract
    i = string.find(source, "http://akas.imdb.com/title/")

    if i != -1:
        lddbsource = source
        source = searchFor(source, "http://akas.imdb.com/title/")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)

        try:
            t2 = open("trace2.html", "w")
            t2.write(source)
            t2.close()
        except:
            print "Unable to write trace2.html"

        print "IMDB link returned"

        try:
            imdbExtract()
        except:
            print "IMDb extraction failed"

        imageref=url
        source = lddbsource




    # Find Image
    i = string.find(source, "<!-- End of Left Table -->")

    if i != -1:
        imdbimage = image
        source = searchForPlus(source, "<!-- End of Left Table -->")
        i = string.find(source, "><img ")
        print "I=",i

        if i < 400:
            image = searchForPlus(source, "><img ")
            image = searchForPlus(image, "src=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])

            i = string.find(image, " [")

            if i != -1:
                image = imdbimage

            i = string.find(image, "PNA.gif")

            if i != -1:
                image = imdbimage


    # Find Title
    i = string.find(source, "width=\"20\"")

    if i != -1:
        source = searchForPlus(source, "width=\"20\"")
        source = searchForPlus(source, "class=\"lddb\">")
        i = string.find(source, "</h3>")
        title = stripText(source[0:i])
        title = string.replace(title, "<i>", "")
        title = string.replace(title, "</i>", "")

        if title[0:3] == "<a ":
            title = searchForPlus(title, "\">")
            

        i = string.rfind(title, " [")

        if i != -1:
            title = stripText(title[0:i])


    # Find Copyright date
    i = string.find(title, " (")

    if i != -1:
        copyDate = stripText(title[i+2:])
        i = string.find(copyDate, ")")
        copyDate = stripText(copyDate[0:i])
        i = string.find(title, " (")
        title = stripText(title[0:i])


    # Find Place
    i = string.find(source, ">Country")

    if i != -1:
        source = searchForPlus(source, ">Country")
        source = searchForPlus(source, "class=\"data\">")
        i = string.find(source, "<")
        place = stripHTML(source[0:i])


    # Find Release date
    date = ""
    i = string.find(source, ">Street date")

    if i != -1:
        source = searchForPlus(source, ">Street date")
        source = searchForPlus(source, "class=\"data\">")
        i = string.find(source, "<")
        date = stripText(source[0:i])
        date = string.replace(date, "???", "")

        if fullDateFormat == "false":
            i = string.rfind(date, " ")

            if i != -1:
                date = stripText(date[i+1:])


    # Find Studio
    i = string.find(source, ">Publisher")

    if i != -1:
        source = searchForPlus(source, ">Publisher")
        source = searchForPlus(source, "class=\"data\">")

        if source.startswith("&nbsp;<a href") == 1:
            source = searchForPlus(source, "\">")
            
        i = string.find(source, "<")
        studio = stripText(source[0:i])


    # Find Price
    i = string.find(source, ">Price")

    if (i != -1):
        source = searchForPlus(source, ">Price")
        source = searchForPlus(source, "class=\"data\">")
        i = string.find(source, "<")
        value = stripText(source[0:i])


    # Find UPC
    i = string.find(source, ">UPC")

    if (i != -1):
        source = searchForPlus(source, ">UPC")
        source = searchForPlus(source, "class=\"data\">")
        i = string.find(source, "<")
        upc = stripText(source[0:i])
        upc = string.replace(upc, "???", "")
        upc = string.replace(upc, "(none)", "")
        upc = stripText(upc)


    # Find Category
    if category == "":
        i = string.find(source, ">Category")

        if i != -1:
            source = searchForPlus(source, ">Category")
            source = searchForPlus(source, "class=\"data\">")

            if source.startswith("&nbsp;<a href") == 1:
                source = searchForPlus(source, "\">")
            
            i = string.find(source, "<")
            category = stripText(source[0:i])


    # Find ISBN
    i = string.find(source, ">I-S-B-N")

    if (i != -1):
        source = searchForPlus(source, ">I-S-B-N")
        source = searchForPlus(source, "class=\"data\">")
        i = string.find(source, "<")
        isbn = stripText(source[0:i])


    # Find Color
    i = string.find(source, ">Color")

    if (i != -1):
        source = searchForPlus(source, ">Color")
        source = searchForPlus(source, "class=\"data\">")
        i = string.find(source, "<")
        color = stripText(source[0:i])


    # Find Running time
    i = string.find(source, ">Length")

    if (i != -1):
        source = searchForPlus(source, ">Length")
        source = searchForPlus(source, "class=\"data\">")
        i = string.find(source, "<")
        running = stripText(source[0:i])
        running = string.replace(running, "???", "")


    # Find Widescreen
    i = string.find(source, "Letterboxed")

    if (i != -1):
        wide = "Y"
    else:
        i = string.find(source, "logo/wide.gif")

        if (i != -1):
            wide = "Y"


    # Find captioning
    i = string.find(source, "logo/cc.gif")

    if (i != -1):
        closedCap = "Y"


    # Find Format
    i = string.find(source, "mode/clv.")

    if i != -1:
        format = "LaserDisc [CLV]"

    i = string.find(source, "mode/cav.")

    if i != -1:
        format = "LaserDisc [CAV]"

    i = string.find(source, "mode/clv_cav.")

    if i != -1:
        format = "LaserDisc [CAV]"


    # Find Sound
    i = string.find(source, "/logo/dolby/surround")

    if i != -1:
        sound = "Dolby Surround"

    i = string.find(source, "/images/sound/20.")

    if i != -1:
        sound = "Stereo"

    i = string.find(source, "/images/sound/10.")

    if i != -1:
        sound = "Mono"





def imdbExtract():
    global title,actor1,actor2,actor3,actor4,actor5,actor6
    global actor7,actor8,actor9,actor10,director,writer
    global screenwriter,photographer,composer,editor,series
    global upc,isbn,lccn,dewey,userNumber,format,studio,place
    global date,copyDate,mpaa,wide,closedCap,sound,copies
    global rating,condition,category,viewed,pflag,eflag,value
    global valueDate,comments,dateEntered,dataSource,cart,ordered
    global copies,location,keywords,book,author,running,color
    global track1,track2,track3,track4,track5
    global track6,track7,track8,track9,track10
    global track11,track12,track13,track14,track15
    global track16,track17,track18,track19,track20
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,salesrank,available
    global buyerwaiting,editionNumber,image,imageref,fullDateFormat,source


    # Defaults
    pflag               = "Y"
    eflag               = "Y"
    color               = "Color"
    sound               = "Mono"
    wide                = "N"
    closedCap           = "N"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"


    # Find Image
    i = string.find(source, "/ImageView")

    if i != -1:
        source = searchForPlus(source, "/ImageView")
        source = searchForPlus(source, "<IMG SRC=\"")
        i = string.find(source, "\"")
        image = stripText(source[0:i])
    else:
        i = string.find(source, "name=\"poster\"")

        if i != -1:
            source = searchForPlus(source, "name=\"poster\"")
            source = searchForPlus(source, "src=\"")
            i = string.find(source, "\"")
            image = stripText(source[0:i])


    # Find Title
    source = searchForPlus(source, "id=\"tn15title\"")
    source = searchForPlus(source, "<h1>")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    title = string.replace(title, "&#34;", "\"")
    title = string.replace(title, "&#38;", "&")


    # Find keywords
    i = string.find(source, "/keywords")

    if i != -1:
        keywords = ""
        url = stripText(source[i-50:])
        url = searchForPlus(url, "href=\"")
        i = string.find(url, "\"")
        url = "http://www.imdb.com" + stripText(url[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        page2 = http.getContents(url)

        try:
            t3 = open("trace3.html", "w")
            t3.write(page2)
            t3.close()
        except:
            print "Unable to write trace3.html"

        i = string.find(page2, "class=\"keyword\"")

        if i != -1:
            page2 = searchForPlus(page2, "class=\"keyword\"")
            i = string.find(page2, "</ul>")
            page2 = stripText(page2[0:i])

            while string.find(page2, "href=\"") != -1:
                page2 = searchForPlus(page2, "href=\"")
                page2 = searchForPlus(page2, "\">")
                i = string.find(page2, "<")
                keyword = stripText(page2[0:i])

                if keywords == "":
                    keywords =keyword   
                else:
                    keywords = keywords + ", " + keyword



    # Find Copyright date
    source = searchForPlus(source, "(")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    copyDate = stripText(source[0:i])


    # Find user rating
    i = string.find(source, ">User Rating:")

    if i != -1:
        rating = searchForPlus(source, ">User Rating:")
        rating = searchForPlus(rating, "<b>")
        i = string.find(rating, "<")
        rating = stripText(rating[0:i]) + " (IMDB)"


    # Find Director
    i = string.find(source, ">Director")

    if i != -1:
        source = searchForPlus(source, ">Director")
        source = searchForPlus(source, "href")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        director = stripText(source[0:i])

        i = string.rfind(director, " ")

        if (i != -1):
            director = stripText(director[i:]) + ", " + stripText(director[0:i])


    # Find writers
    i = string.find(source, ">Writers")

    if i != -1:
        source = searchForPlus(source, ">Writers")
        i = string.find(source, "<br/>\n")
        writers = stripText(source[0:i])

        screenwriter = ""
        author = ""
        writer = ""

        while (searchFor(writers, "href") != None):
            writers = searchForPlus(writers, "href")
            writers = searchForPlus(writers, ">")
            i = string.find(writers, "<br/>")
            tempWriter = stripText(writers[0:i])
            writerType = 0

            if string.find(tempWriter, "(novel)") != -1:
                writerType = 1

            if string.find(tempWriter, "(story)") != -1:
                writerType = 2

            if string.find(tempWriter, "(short story)") != -1:
                writerType = 2

            i = string.find(tempWriter, "<")
            tempWriter = stripText(tempWriter[0:i])

            i = string.find(tempWriter, "(")

            if i != -1:
                tempWriter = stripText(tempWriter[0:i])

            i = string.rfind(tempWriter, " ")

            if i != -1:
                tempWriter = stripText(tempWriter[i:]) + ", " + stripText(tempWriter[0:i])

            if tempWriter != "(more)" and tempWriter != "WGA" and tempWriter != "":
                if writerType == 0:
                    if screenwriter != "":
                        screenwriter = screenwriter + " / "

                    screenwriter = screenwriter + tempWriter
                elif writerType == 1:
                    if author != "":
                        author = author + " / "

                    author = author + tempWriter
                    book = title
                elif writerType == 2:
                    if writer != "":
                        writer = writer + " / "

                    writer = writer + tempWriter


    # Find Category
    i = string.find(source, ">Genre")

    if i != -1:
        source = searchForPlus(source, ">Genre")
        i = string.find(source, "</div>")
        categories = stripText(source[0:i])
        category = ""

        while (searchFor(categories, "href") != None):
            categories = searchForPlus(categories, "href")
            categories = searchForPlus(categories, ">")
            i = string.find(categories, "<")

            next = stripText(categories[0:i])

            if next != "more":
                if (category != ""):
                    category = category + " : "

                category = category + next

            categories = categories[i:]


    # Find Comments
    i = string.find(source, ">Plot")

    if i != -1:
        source = searchForPlus(source, ">Plot")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        comments = stripText(source[0:i])


    # Find Actors
    castTag = "XXX"

    i = string.find(source, "class=\"cast\"")

    if i != -1:
        castTag = "class=\"cast\""

    i = string.find(source, castTag)

    if i != -1:
        source = searchForPlus(source, castTag)
        i = string.find(source, "</div>")
        actors = stripText(source[0:i])
        actorList = []

        while (searchFor(actors, "<tr") != None):
            actors = searchForPlus(actors, "<tr")
            i = string.find(actors, "</tr>")

            if (i == -1):
                actor = actors
            else:
                actor = stripText(actors[0:i])

            actors = searchForPlus(actors, "</tr>")
            i = string.rfind(actor, "href=\"/name")

            if (i != -1):
                actor = stripText(actor[i:])
                actor = searchForPlus(actor, "\">")
                i = string.find(actor, "<")
                actor = stripText(actor[0:i])

                i = string.find(actor, "(")

                if i != -1:
                    actor = stripText(actor[0:i])

                i = string.rfind(actor, " ")

                if (i != -1):
                    actor = stripText(actor[i:]) + ", " + stripText(actor[0:i])

                actorList.append(actor)

        if len(actorList) > 0:
            actor1 = actorList[0]

        if len(actorList) > 1:
            actor2 = actorList[1]

        if len(actorList) > 2:
            actor3 = actorList[2]

        if len(actorList) > 3:
            actor4 = actorList[3]

        if len(actorList) > 4:
            actor5 = actorList[4]

        if len(actorList) > 5:
            actor6 = actorList[5]

        if len(actorList) > 6:
            actor7 = actorList[6]

        if len(actorList) > 7:
            actor8 = actorList[7]

        if len(actorList) > 8:
            actor9 = actorList[8]

        if len(actorList) > 9:
            actor10 = actorList[9]



    # Find Running time
    i = string.find(source, ">Runtime")

    if i != -1:
        temp = searchForPlus(source, ">Runtime")
        i = string.find(temp, "</div>")

        if i != -1:
            temp = stripText(temp[0:i+1])

        i = string.find(temp, "USA:")

        if i != -1:
            temp = searchForPlus(temp, "USA:")
            i = string.find(temp, "<")
            running = stripText(temp[0:i])
        else:
            temp = searchForPlus(temp, ">")
            i = string.find(temp, "<")
            running = stripText(temp[0:i])
            i = string.find(running, ":")

            if i != -1:
                running = stripText(running[i+1:])


    # Find Place
    i = string.find(source, ">Country")

    if i != -1:
        source = searchForPlus(source, ">Country")
        source = searchForPlus(source, "href")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        place = stripText(source[0:i])


    # Find Color
    i = string.find(source, ">Color")

    if i != -1:
        source = searchForPlus(source, ">Color")
        source = searchForPlus(source, "href")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        color = stripText(source[0:i])


    # Find Sound
    i = string.find(source, ">Sound")

    if i != -1:
        source = searchForPlus(source, ">Sound")
        source = searchForPlus(source, "href")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        sound = stripText(source[0:i])


    # Find Rating
    i = string.find(source, ">Certification")

    if i != -1:
        source = searchForPlus(source, ">Certification")
        i = string.find(source, ">USA:")

        if i != -1:
            source = searchForPlus(source, ">USA:")
            i = string.find(source, "<")
            mpaa = stripText(source[0:i]) + " (MPAA)"
        else:
            source = searchForPlus(source, "href")
            source = searchForPlus(source, ">")
            i = string.find(source, "<")
            mpaa = stripText(source[0:i])




# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*


try:
    extract()
finally:
    if os.path.exists("scrapers/vwuserexit.py"):
        execfile("scrapers/vwuserexit.py") in globals()
